use core::ops::{Rem, RemAssign};

use num_bigint::BigUint;

use super::Ex3Uint;

#[macro_export(local_inner_macros)]
macro_rules! impl_rem_uint_for {
  ($for_type:ty, $($t:ty),*) => {
    $(
      impl Rem<$t> for $for_type {
        type Output = $for_type;

        fn rem(mut self, rhs: $t) -> Self::Output {
          self %= rhs;
          self
        }
      }
    )*
  };
}

#[macro_export(local_inner_macros)]
macro_rules! impl_rem_assign_uint_for {
  ($for_type:ty, $($t:ty),*) => {
    $(
      impl RemAssign<$t> for $for_type {
        fn rem_assign(&mut self, rhs: $t) {
          self.0 %= rhs;
        }
      }
    )*
  };
}

impl_rem_uint_for!(Ex3Uint, u8, u16, u32, u64, u128, usize, BigUint);
impl_rem_assign_uint_for!(Ex3Uint, u8, u16, u32, u64, u128, usize, BigUint);
